=== added file 'src/com/goldencode/p2j/testengine/UnitTestServer.java'
--- src/com/goldencode/p2j/testengine/UnitTestServer.java	1970-01-01 00:00:00 +0000
+++ src/com/goldencode/p2j/testengine/UnitTestServer.java	2022-10-28 20:58:09 +0000
@@ -0,0 +1,459 @@
+/*
+** Module   : UnitTestServer.java
+** Abstract : FWD unit test remote protocol implementation
+**
+** Copyright (c) 2022, Golden Code Development Corporation.
+**
+** -#- -I- --Date-- ----------------Description----------------------
+** 001 VVT 2022xxxx Created initial version.
+*/
+/*
+** This program is free software: you can redistribute it and/or modify
+** it under the terms of the GNU Affero General Public License as
+** published by the Free Software Foundation, either version 3 of the
+** License, or (at your option) any later version.
+**
+** This program is distributed in the hope that it will be useful,
+** but WITHOUT ANY WARRANTY; without even the implied warranty of
+** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+** GNU Affero General Public License for more details.
+**
+** You may find a copy of the GNU Affero GPL version 3 at the following
+** location: https://www.gnu.org/licenses/agpl-3.0.en.html
+** 
+** Additional terms under GNU Affero GPL version 3 section 7:
+** 
+**   Under Section 7 of the GNU Affero GPL version 3, the following additional
+**   terms apply to the works covered under the License.  These additional terms
+**   are non-permissive additional terms allowed under Section 7 of the GNU
+**   Affero GPL version 3 and may not be removed by you.
+** 
+**   0. Attribution Requirement.
+** 
+**     You must preserve all legal notices or author attributions in the covered
+**     work or Appropriate Legal Notices displayed by works containing the covered
+**     work.  You may not remove from the covered work any author or developer
+**     credit already included within the covered work.
+** 
+**   1. No License To Use Trademarks.
+** 
+**     This license does not grant any license or rights to use the trademarks
+**     Golden Code, FWD, any Golden Code or FWD logo, or any other trademarks
+**     of Golden Code Development Corporation. You are not authorized to use the
+**     name Golden Code, FWD, or the names of any author or contributor, for
+**     publicity purposes without written authorization.
+** 
+**   2. No Misrepresentation of Affiliation.
+** 
+**     You may not represent yourself as Golden Code Development Corporation or FWD.
+** 
+**     You may not represent yourself for publicity purposes as associated with
+**     Golden Code Development Corporation, FWD, or any author or contributor to
+**     the covered work, without written authorization.
+** 
+**   3. No Misrepresentation of Source or Origin.
+** 
+**     You may not represent the covered work as solely your work.  All modified
+**     versions of the covered work must be marked in a reasonable way to make it
+**     clear that the modified work is not originating from Golden Code Development
+**     Corporation or FWD.  All modified versions must contain the notices of
+**     attribution required in this license.
+*/
+package com.goldencode.p2j.testengine;
+
+import java.lang.annotation.*;
+import java.lang.reflect.*;
+import java.util.*;
+
+import org.junit.platform.commons.support.*;
+import org.junit.platform.commons.util.*;
+import org.junit.platform.engine.*;
+
+import com.goldencode.p2j.oo.lang.*;
+import com.goldencode.p2j.persist.*;
+import com.goldencode.p2j.security.*;
+import com.goldencode.p2j.testengine.api.*;
+import com.goldencode.p2j.util.*;
+import com.google.common.collect.*;
+
+/**
+ * FWD unit testing engine remote operation server-side implementation.
+ * 
+ * This class contains static methods matching the {@link UnitTestEngine} interface.
+ */
+public class UnitTestServer
+{
+   /** Context local work area. */
+   private static final ContextLocal<WorkArea> context = new ContextLocal<WorkArea>()
+   {
+      @Override
+      protected WorkArea initialValue()
+      {
+         return new WorkArea();
+      };
+   };
+
+   /**
+    * Execute the <em>after</em> behavior of this node.
+    *
+    * <p>This method will be called once <em>after</em> {@linkplain #execute
+    * execution} of this node.
+    * 
+    * @param testId
+    *        test descriptor ID
+    *
+    * @throws Exception 
+    * 
+    */
+   public static void after(final UniqueId testId) throws Exception
+   {
+      final AbstractFWDTestDescriptor desc = getDescriptor(testId);
+      assert desc != null;
+      System.err.println("after: " + testId + " desc: " + desc);
+      desc.afterImpl();
+   }
+
+   /**
+    * Execute the <em>before</em> behavior of this node.
+    *
+    * <p>This method will be called once <em>before</em> {@linkplain #execute
+    * execution} of this node.
+    * 
+    * @param testId 
+    *        test descriptor ID
+    *
+    * @throws Exception 
+    */
+   public static void before(final UniqueId testId) throws Exception
+   {
+      final AbstractFWDTestDescriptor desc = getDescriptor(testId);
+      assert desc != null;
+      System.err.println("before: " + testId + " desc: " + desc);
+      desc.beforeImpl();
+   }
+
+   /**
+    * Clean up the supplied {@code context} after execution.
+    * 
+    * Reset the test class instance.
+    * @param testId 
+    *        test descriptor ID
+    *
+    * @throws Exception 
+    *
+    * @see #prepare
+    */
+   public static void cleanUp(final UniqueId testId) throws Exception
+   {
+      final AbstractFWDTestDescriptor desc = getDescriptor(testId);
+      assert desc != null;
+      System.err.println("cleanUp : " + testId + " desc: " + desc);
+      desc.cleanUpImpl();
+   }
+
+   /**
+    * Do test discovery.
+    * 
+    * Currently supports scanning Java packages, Java classes and Java methods for tests
+    * 
+    * @param uniqueId 
+    *        the test engine uniqueId 
+    * @param packageSelectors
+    *        selectors for Java packages to scan
+    * @param classSelectors 
+    *        selectors for Java classes to scan
+    * @param methodSelectors 
+    *        selectors for Java methods to scan
+    * 
+    * @return a test descriptor with all test descriptors discovered as children
+    *  
+    */
+   public static TestDescriptor discover(final UniqueId uniqueId, final String[] packageSelectors,
+            final String[] classSelectors, final String[] methodSelectors)
+   {
+      // Create and register the root engine descriptor
+      final AbstractFWDTestDescriptor engineDescriptor = new FWDEngineDescriptor(uniqueId);
+
+      register(engineDescriptor);
+
+      try
+      {
+         for (final String methodId : methodSelectors)
+         {
+            final int delimeterIdx = methodId.indexOf('#');
+            assert delimeterIdx > 0;
+            final String className = methodId.substring(0, delimeterIdx);
+            final Class<?> clazz = Class.forName(className);
+            final String methodName = methodId.substring(delimeterIdx);
+            final Method method = clazz.getMethod(methodName);
+
+            addOptionally(engineDescriptor, clazz, method);
+         }
+
+         for (final String selector : classSelectors)
+         {
+            scanClass(engineDescriptor, Class.forName(selector));
+         }
+      }
+      catch (ClassNotFoundException | NoSuchMethodException | SecurityException e)
+      {
+         throw new RuntimeException(e);
+      }
+
+      for (final String selector : packageSelectors)
+      {
+         // Note: we need to restrict the search by only the classes immediately located in the package,
+         // excluding all classes in sub-packages
+         final List<Class<?>> classes = ReflectionSupport.findAllClassesInPackage(selector,
+                  (Class<?> c) -> selector.equals(c.getPackage().getName()), name -> true);
+         for (Class<?> javaClass : classes)
+         {
+            scanClass(engineDescriptor, javaClass);
+         }
+      }
+
+      return engineDescriptor;
+   }
+
+   /**
+    * Execute the <em>behavior</em> of this node.
+    *
+    * Locate the test descriptor by its unique ID and calls
+    * {@link AbstractFWDTestDescriptor#executeImpl()}
+    * 
+    * @param testId
+    *        test descriptor ID
+    * 
+    * @throws Exception 
+    *
+    */
+   public static void execute(final UniqueId testId) throws Exception
+   {
+      final AbstractFWDTestDescriptor desc = getDescriptor(testId);
+      assert desc != null;
+      System.err.println("execute: " + testId + " desc: " + desc);
+      desc.executeImpl();
+   }
+
+   /**
+    * Initialize FWD server.
+    */
+   public static void initialize()
+   {
+      // this is an app server and needs its own management
+      if (AppServerManager.startAppServer())
+      {
+         throw new RuntimeException("Cannot start AppServer");
+      }
+
+      //      if (params.batchMode > 0)
+      //      {
+      //         // run this connection in batch mode (as requested from client command-line)
+      //         EnvironmentOps.setBatchMode(true);
+      //         // LogicalTerminal.activateBatchMode(true); -- should already be set ?
+      //      }
+
+      DatabaseManager.autoConnect();
+   }
+
+   /**
+    * Prepare test descriptor.
+    * 
+    * Locate the test descriptor by its unique ID and calls
+    * {@link AbstractFWDTestDescriptor#prepareImpl()}
+    * 
+    * @param testId 
+    *        test descriptor ID
+    *        
+    * @throws Exception 
+    */
+   public static void prepare(final UniqueId testId) throws Exception
+   {
+      final AbstractFWDTestDescriptor desc = getDescriptor(testId);
+      assert desc != null;
+      System.err.println("prepare : " + testId + " desc: " + desc);
+      desc.prepareImpl();
+   }
+
+   /**
+    * Scan a class for test methods, declared in the class.
+    * 
+    * @param engineDescriptor
+    *        the engine descriptor to register found test descriptors in
+    * @param javaClass
+    *        the Java class to scan
+    * @param explicitMethods
+    *        optional list of explicit test methods to execute, can be {@code null}
+    */
+   private final static void addOptionally(final TestDescriptor engineDescriptor,
+            final Class<?> javaClass, final Method explicitMethods)
+   {
+      final AbstractClassTestDescriptor instance = testAndCreate(javaClass, engineDescriptor,
+               explicitMethods);
+      if (instance != null)
+      {
+         engineDescriptor.addChild(instance);
+      }
+   }
+
+   /**
+    * Collect all methods annotated with the given class, but not annotated as disabled.
+    * 
+    * @param clazz
+    *        the class to scan for methods
+    * @param annoClass
+    *        the annotation class to match
+    * @param topDown
+    *        if {@code true}, then traverse class hierarchy top-down, otherwise traverse bottom-up.
+    * @return
+    *        the list of methods found; never {@code null}
+    */
+   private final static List<Method> collectAnnotatedMethods(final Class<?> clazz,
+            final Class<? extends Annotation> annoClass, final boolean topDown)
+   {
+      return ReflectionUtils.findMethods(clazz,
+               m -> AnnotationUtils.isAnnotated(m, annoClass)
+                        && !AnnotationUtils.isAnnotated(m, Disabled.class),
+               topDown ? ReflectionUtils.HierarchyTraversalMode.TOP_DOWN
+                        : ReflectionUtils.HierarchyTraversalMode.BOTTOM_UP);
+   }
+
+   /**
+    * Find descriptor by its ID.
+    * 
+    * @param testId
+    *        unique ID
+    *        
+    * @return the test descriptor.
+    */
+   private final static AbstractFWDTestDescriptor getDescriptor(final UniqueId testId)
+   {
+      return context.get().testDescriptorRegistry.get(testId);
+   }
+
+   /**
+    * Register a new descriptor.
+    * 
+    * @param descriptor
+    */
+   private final static void register(final AbstractFWDTestDescriptor descriptor)
+   {
+      final Map<UniqueId, AbstractFWDTestDescriptor> registry = context
+               .get().testDescriptorRegistry;
+      final UniqueId uniqueId = descriptor.getUniqueId();
+
+      // The same class can be collected more than once in case test suites are present 
+      if (!registry.containsKey(uniqueId))
+      {
+         registry.put(uniqueId, descriptor);
+      }
+   }
+
+   /**
+    * Recursively scan a class for all test methods, including whose defined in the class
+    * and referenced classes, if the class is marked as test suite.
+    * 
+    * @param engineDescriptor
+    *        the engine descriptor to register found test descriptors in
+    * @param javaClass
+    *        the Java class to scan
+    */
+   private final static void scanClass(final TestDescriptor engineDescriptor,
+            final Class<?> javaClass)
+   {
+      addOptionally(engineDescriptor, javaClass, null);
+      // Add suites
+      if (AnnotationSupport.isAnnotated(javaClass, Suite.class))
+      {
+         final SelectClasses classesAnnotation = javaClass.getAnnotation(SelectClasses.class);
+         if (classesAnnotation != null)
+         {
+            for (final Class<?> referencedClass : classesAnnotation.value())
+            {
+               scanClass(engineDescriptor, referencedClass);
+            }
+         }
+
+         final SelectProcedures proceduresAnnotation = javaClass
+                  .getAnnotation(SelectProcedures.class);
+         if (proceduresAnnotation != null)
+         {
+            for (final String procedureName : proceduresAnnotation.value())
+            {
+               try
+               {
+                  final String className = SourceNameMapper.convertNameToClass(procedureName);
+                  if (className == null)
+                  {
+                     throw new RuntimeException("Cannot resolve class for procedure: " + procedureName);
+                  }
+                  
+                  addOptionally(engineDescriptor, Class.forName(className), null);
+               }
+               catch (ClassNotFoundException e)
+               {
+                  throw new RuntimeException("Cannot find class: " + e);
+               }
+            }
+         }
+      }
+   }
+
+   /**
+    * Test a Java class candidate for existent tests methods. If found, create a new class
+    * test descriptor.
+    * 
+    * @param clazz
+    *        the class under test 
+    * @param parentDescriptor
+    *        the parent descriptor
+    * @param optionalMethod
+    *        the explicit method or {@code null} to scan the class for all test methods
+    *        
+    * @return  the class test descriptor or {@code null} if this class has no test methods.
+    */
+   private final static AbstractClassTestDescriptor testAndCreate(final Class<?> clazz,
+            final TestDescriptor parentDescriptor, Method optionalMethod)
+   {
+      // FIXME: find out if the test for abstract classes is really necessary.
+      // For example, Eclipse does not run abstract classes as JUnit test
+      if (Modifier.isAbstract(clazz.getModifiers()))
+      {
+         return null;
+      }
+
+      final List<Method> test = optionalMethod != null ? Lists.newArrayList(optionalMethod)
+               : collectAnnotatedMethods(clazz, Test.class, true);
+
+      if (test.isEmpty())
+      {
+         return null;
+      }
+
+      final List<Method> beforeEach = collectAnnotatedMethods(clazz, BeforeEach.class, true);
+      final List<Method> afterEach = collectAnnotatedMethods(clazz, AfterEach.class, false);
+      final List<Method> beforeAll = collectAnnotatedMethods(clazz, BeforeAll.class, true);
+      final List<Method> afterAll = collectAnnotatedMethods(clazz, AfterAll.class, false);
+      final AbstractClassTestDescriptor classDescriptor = BaseObject.class.isAssignableFrom(clazz)
+               ? new FWDClassTestDescriptor(clazz, parentDescriptor, test, beforeEach, afterEach,
+                        beforeAll, afterAll)
+               : new FWDProcedureTestDescriptor(clazz, parentDescriptor, test, beforeEach,
+                        afterEach, beforeAll, afterAll);
+      register(classDescriptor);
+
+      for (TestDescriptor child : classDescriptor.getChildren())
+      {
+         register((AbstractFWDTestDescriptor) child);
+      }
+
+      return classDescriptor;
+   }
+
+   /**
+    * Context local work area.
+    */
+   private static class WorkArea
+   {
+      private final Map<UniqueId, AbstractFWDTestDescriptor> testDescriptorRegistry = new HashMap<>();
+   }
+}

=== added file 'src/com/goldencode/p2j/testengine/api/AfterAll.java'
--- src/com/goldencode/p2j/testengine/api/AfterAll.java	1970-01-01 00:00:00 +0000
+++ src/com/goldencode/p2j/testengine/api/AfterAll.java	2022-09-30 12:24:40 +0000
@@ -0,0 +1,74 @@
+/*
+** Module   : AfterAll.java
+** Abstract : Mark methods, which should be run after all @Test methods in the class.
+**
+** Copyright (c) 2022, Golden Code Development Corporation.
+**
+** -#- -I- --Date-- ----------------Description----------------------
+** 001 VVT 2022xxxx Created initial version.
+*/
+/*
+** This program is free software: you can redistribute it and/or modify
+** it under the terms of the GNU Affero General Public License as
+** published by the Free Software Foundation, either version 3 of the
+** License, or (at your option) any later version.
+**
+** This program is distributed in the hope that it will be useful,
+** but WITHOUT ANY WARRANTY; without even the implied warranty of
+** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+** GNU Affero General Public License for more details.
+**
+** You may find a copy of the GNU Affero GPL version 3 at the following
+** location: https://www.gnu.org/licenses/agpl-3.0.en.html
+** 
+** Additional terms under GNU Affero GPL version 3 section 7:
+** 
+**   Under Section 7 of the GNU Affero GPL version 3, the following additional
+**   terms apply to the works covered under the License.  These additional terms
+**   are non-permissive additional terms allowed under Section 7 of the GNU
+**   Affero GPL version 3 and may not be removed by you.
+** 
+**   0. Attribution Requirement.
+** 
+**     You must preserve all legal notices or author attributions in the covered
+**     work or Appropriate Legal Notices displayed by works containing the covered
+**     work.  You may not remove from the covered work any author or developer
+**     credit already included within the covered work.
+** 
+**   1. No License To Use Trademarks.
+** 
+**     This license does not grant any license or rights to use the trademarks
+**     Golden Code, FWD, any Golden Code or FWD logo, or any other trademarks
+**     of Golden Code Development Corporation. You are not authorized to use the
+**     name Golden Code, FWD, or the names of any author or contributor, for
+**     publicity purposes without written authorization.
+** 
+**   2. No Misrepresentation of Affiliation.
+** 
+**     You may not represent yourself as Golden Code Development Corporation or FWD.
+** 
+**     You may not represent yourself for publicity purposes as associated with
+**     Golden Code Development Corporation, FWD, or any author or contributor to
+**     the covered work, without written authorization.
+** 
+**   3. No Misrepresentation of Source or Origin.
+** 
+**     You may not represent the covered work as solely your work.  All modified
+**     versions of the covered work must be marked in a reasonable way to make it
+**     clear that the modified work is not originating from Golden Code Development
+**     Corporation or FWD.  All modified versions must contain the notices of
+**     attribution required in this license.
+*/
+package com.goldencode.p2j.testengine.api;
+
+import java.lang.annotation.*;
+
+/**
+ * {@link AfterAll} is used to mark methods, which should be run after all {@link Test} methods in the class.
+ */
+@Target(ElementType.METHOD)
+@Retention(RetentionPolicy.RUNTIME)
+public @interface AfterAll
+{
+   // no-op
+}

=== added file 'src/com/goldencode/p2j/testengine/api/AfterEach.java'
--- src/com/goldencode/p2j/testengine/api/AfterEach.java	1970-01-01 00:00:00 +0000
+++ src/com/goldencode/p2j/testengine/api/AfterEach.java	2022-09-30 12:24:46 +0000
@@ -0,0 +1,74 @@
+/*
+** Module   : AfterEach.java
+** Abstract : Mark methods, which should be run after each @Test method.
+**
+** Copyright (c) 2022, Golden Code Development Corporation.
+**
+** -#- -I- --Date-- ----------------Description----------------------
+** 001 VVT 2022xxxx Created initial version.
+*/
+/*
+** This program is free software: you can redistribute it and/or modify
+** it under the terms of the GNU Affero General Public License as
+** published by the Free Software Foundation, either version 3 of the
+** License, or (at your option) any later version.
+**
+** This program is distributed in the hope that it will be useful,
+** but WITHOUT ANY WARRANTY; without even the implied warranty of
+** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+** GNU Affero General Public License for more details.
+**
+** You may find a copy of the GNU Affero GPL version 3 at the following
+** location: https://www.gnu.org/licenses/agpl-3.0.en.html
+** 
+** Additional terms under GNU Affero GPL version 3 section 7:
+** 
+**   Under Section 7 of the GNU Affero GPL version 3, the following additional
+**   terms apply to the works covered under the License.  These additional terms
+**   are non-permissive additional terms allowed under Section 7 of the GNU
+**   Affero GPL version 3 and may not be removed by you.
+** 
+**   0. Attribution Requirement.
+** 
+**     You must preserve all legal notices or author attributions in the covered
+**     work or Appropriate Legal Notices displayed by works containing the covered
+**     work.  You may not remove from the covered work any author or developer
+**     credit already included within the covered work.
+** 
+**   1. No License To Use Trademarks.
+** 
+**     This license does not grant any license or rights to use the trademarks
+**     Golden Code, FWD, any Golden Code or FWD logo, or any other trademarks
+**     of Golden Code Development Corporation. You are not authorized to use the
+**     name Golden Code, FWD, or the names of any author or contributor, for
+**     publicity purposes without written authorization.
+** 
+**   2. No Misrepresentation of Affiliation.
+** 
+**     You may not represent yourself as Golden Code Development Corporation or FWD.
+** 
+**     You may not represent yourself for publicity purposes as associated with
+**     Golden Code Development Corporation, FWD, or any author or contributor to
+**     the covered work, without written authorization.
+** 
+**   3. No Misrepresentation of Source or Origin.
+** 
+**     You may not represent the covered work as solely your work.  All modified
+**     versions of the covered work must be marked in a reasonable way to make it
+**     clear that the modified work is not originating from Golden Code Development
+**     Corporation or FWD.  All modified versions must contain the notices of
+**     attribution required in this license.
+*/
+package com.goldencode.p2j.testengine.api;
+
+import java.lang.annotation.*;
+
+/**
+ * {@link AfterEach} is used to mark methods, which should be run after each {@link Test} method.
+ */
+@Target(ElementType.METHOD)
+@Retention(RetentionPolicy.RUNTIME)
+public @interface AfterEach
+{
+   // no-op
+}

=== added file 'src/com/goldencode/p2j/testengine/api/BeforeAll.java'
--- src/com/goldencode/p2j/testengine/api/BeforeAll.java	1970-01-01 00:00:00 +0000
+++ src/com/goldencode/p2j/testengine/api/BeforeAll.java	2022-09-30 12:24:50 +0000
@@ -0,0 +1,75 @@
+/*
+** Module   : BeforeAll.java
+** Abstract : Mark methods, which should be run before all @Test methods in the class.
+**
+** Copyright (c) 2022, Golden Code Development Corporation.
+**
+** -#- -I- --Date-- ----------------Description----------------------
+** 001 VVT 2022xxxx Created initial version.
+*/
+/*
+** This program is free software: you can redistribute it and/or modify
+** it under the terms of the GNU Affero General Public License as
+** published by the Free Software Foundation, either version 3 of the
+** License, or (at your option) any later version.
+**
+** This program is distributed in the hope that it will be useful,
+** but WITHOUT ANY WARRANTY; without even the implied warranty of
+** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+** GNU Affero General Public License for more details.
+**
+** You may find a copy of the GNU Affero GPL version 3 at the following
+** location: https://www.gnu.org/licenses/agpl-3.0.en.html
+** 
+** Additional terms under GNU Affero GPL version 3 section 7:
+** 
+**   Under Section 7 of the GNU Affero GPL version 3, the following additional
+**   terms apply to the works covered under the License.  These additional terms
+**   are non-permissive additional terms allowed under Section 7 of the GNU
+**   Affero GPL version 3 and may not be removed by you.
+** 
+**   0. Attribution Requirement.
+** 
+**     You must preserve all legal notices or author attributions in the covered
+**     work or Appropriate Legal Notices displayed by works containing the covered
+**     work.  You may not remove from the covered work any author or developer
+**     credit already included within the covered work.
+** 
+**   1. No License To Use Trademarks.
+** 
+**     This license does not grant any license or rights to use the trademarks
+**     Golden Code, FWD, any Golden Code or FWD logo, or any other trademarks
+**     of Golden Code Development Corporation. You are not authorized to use the
+**     name Golden Code, FWD, or the names of any author or contributor, for
+**     publicity purposes without written authorization.
+** 
+**   2. No Misrepresentation of Affiliation.
+** 
+**     You may not represent yourself as Golden Code Development Corporation or FWD.
+** 
+**     You may not represent yourself for publicity purposes as associated with
+**     Golden Code Development Corporation, FWD, or any author or contributor to
+**     the covered work, without written authorization.
+** 
+**   3. No Misrepresentation of Source or Origin.
+** 
+**     You may not represent the covered work as solely your work.  All modified
+**     versions of the covered work must be marked in a reasonable way to make it
+**     clear that the modified work is not originating from Golden Code Development
+**     Corporation or FWD.  All modified versions must contain the notices of
+**     attribution required in this license.
+*/
+package com.goldencode.p2j.testengine.api;
+
+import java.lang.annotation.*;
+
+/**
+ * {@link BeforeAll} is used to mark methods, which should be run before all {@link Test} methods
+ * in the class.
+ */
+@Target(ElementType.METHOD)
+@Retention(RetentionPolicy.RUNTIME)
+public @interface BeforeAll
+{
+   // no-op
+}

=== added file 'src/com/goldencode/p2j/testengine/api/BeforeEach.java'
--- src/com/goldencode/p2j/testengine/api/BeforeEach.java	1970-01-01 00:00:00 +0000
+++ src/com/goldencode/p2j/testengine/api/BeforeEach.java	2022-09-30 12:25:01 +0000
@@ -0,0 +1,74 @@
+/*
+** Module   : BeforeEach.java
+** Abstract : Mark methods, which should be run before each @Test method.
+**
+** Copyright (c) 2022, Golden Code Development Corporation.
+**
+** -#- -I- --Date-- ----------------Description----------------------
+** 001 VVT 2022xxxx Created initial version.
+*/
+/*
+** This program is free software: you can redistribute it and/or modify
+** it under the terms of the GNU Affero General Public License as
+** published by the Free Software Foundation, either version 3 of the
+** License, or (at your option) any later version.
+**
+** This program is distributed in the hope that it will be useful,
+** but WITHOUT ANY WARRANTY; without even the implied warranty of
+** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+** GNU Affero General Public License for more details.
+**
+** You may find a copy of the GNU Affero GPL version 3 at the following
+** location: https://www.gnu.org/licenses/agpl-3.0.en.html
+** 
+** Additional terms under GNU Affero GPL version 3 section 7:
+** 
+**   Under Section 7 of the GNU Affero GPL version 3, the following additional
+**   terms apply to the works covered under the License.  These additional terms
+**   are non-permissive additional terms allowed under Section 7 of the GNU
+**   Affero GPL version 3 and may not be removed by you.
+** 
+**   0. Attribution Requirement.
+** 
+**     You must preserve all legal notices or author attributions in the covered
+**     work or Appropriate Legal Notices displayed by works containing the covered
+**     work.  You may not remove from the covered work any author or developer
+**     credit already included within the covered work.
+** 
+**   1. No License To Use Trademarks.
+** 
+**     This license does not grant any license or rights to use the trademarks
+**     Golden Code, FWD, any Golden Code or FWD logo, or any other trademarks
+**     of Golden Code Development Corporation. You are not authorized to use the
+**     name Golden Code, FWD, or the names of any author or contributor, for
+**     publicity purposes without written authorization.
+** 
+**   2. No Misrepresentation of Affiliation.
+** 
+**     You may not represent yourself as Golden Code Development Corporation or FWD.
+** 
+**     You may not represent yourself for publicity purposes as associated with
+**     Golden Code Development Corporation, FWD, or any author or contributor to
+**     the covered work, without written authorization.
+** 
+**   3. No Misrepresentation of Source or Origin.
+** 
+**     You may not represent the covered work as solely your work.  All modified
+**     versions of the covered work must be marked in a reasonable way to make it
+**     clear that the modified work is not originating from Golden Code Development
+**     Corporation or FWD.  All modified versions must contain the notices of
+**     attribution required in this license.
+*/
+package com.goldencode.p2j.testengine.api;
+
+import java.lang.annotation.*;
+
+/**
+ * {@link BeforeEach} is used to mark methods, which should be run before each {@link Test} method.
+ */
+@Target(ElementType.METHOD)
+@Retention(RetentionPolicy.RUNTIME)
+public @interface BeforeEach
+{
+   // no-op
+}

